package android.lib.database;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks a class as a database table.
 * <p>The annotated class must have at least one field annotated by {@link Column @Column}.</p>
 * @see Column
 */
@Target({ ElementType.TYPE })
@Retention(RetentionPolicy.RUNTIME)
public @interface Table {
    /**
     * The name of the database table.
     * <p>If not specified, the name in exact case of the annotated class will be used.</p>
     */
    String value() default "";
}
