package android.lib.database;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Specifies a {@link TypeConverter} to convert the value of a field to and from
 * its underlying value in the database.
 * <p>The annotated field must also be annotated with {@link Column @Column}.
 * @see Column
 */
@Target({ ElementType.TYPE })
@Retention(RetentionPolicy.RUNTIME)
public @interface UseConverter {
    /**
     * The {@link TypeConverter} to use for type conversion.
     */
    Class<TypeConverter<?, ?>> value();
}
