package android.lib.database.predicate;

import java.util.ArrayList;
import java.util.List;

final class TwoSidedPredicate extends Predicate {
    private TwoSidedPredicate(final String predicate, final List<Object> parameters) {
        super(predicate, parameters);
    }

    public static TwoSidedPredicate newInstance(final String template, final Object left, final Object right, final boolean leftIsValue, final boolean rightIsValue) {
        final List<Object> parameters = new ArrayList<Object>();
        final String       predicate;

        if (leftIsValue) {
            parameters.add(left);
        }

        if (rightIsValue) {
            parameters.add(right);
        }

        if (leftIsValue) {
            if (rightIsValue) {
                predicate = String.format(template, Predicate.PARAMETER, Predicate.PARAMETER);
            } else {
                predicate = String.format(template, Predicate.PARAMETER, right.toString());
            }
        } else {
            if (rightIsValue) {
                predicate = String.format(template, left, Predicate.PARAMETER);
            } else {
                predicate = String.format(template, left, right);
            }
        }

        return new TwoSidedPredicate(predicate, parameters);
    }
}
